import requests
import json
import pprint
import datetime

def open_phone(posting_number):
  url = "https://api-seller.ozon.ru" # Cсылку нужно поменять на боевую среду api-seller.ozon.ru
  method = "/v3/posting/fbs/get" # Список заказов
  
  head = {
  "Client-Id": "530468", # сюда клиент id
  "Api-Key": "9ebfa77c-bc55-4d5e-8f33-cc02600bdd52" # Сюда Api-Key
  }
  body = {

    "posting_number": posting_number
  }
  
  body = json.dumps(body) # Нужно передавать в озон именно так, потому что string он как json не понимает
  response = requests.post(url + method, headers=head, data=body)
  print("Узнает номер телефона: ")
  print(response.text)
  phone_s = json.loads(response.text)
  phone = phone_s['result']['customer']['phone']
  return (phone)


def open_sku(sku):
  
  sku_full = {
    "height": "",
    "depth": "",
    "width": "",
    "weight": "",
    "weight_unit": "g"
  }
  
  url = "https://api-seller.ozon.ru" # Cсылку нужно поменять на боевую среду api-seller.ozon.ru
  method = "/v3/products/info/attributes" # Узнаем параметры товара
  #print("Узнаем параметры товара: ", sku)

  body = {
   "filter": {
     "sku": [sku],
      "visibility": "ALL"
    },
    "limit": 100,
    "last_id": "",
    "sort_dir": "ASC"
  }

  body = json.dumps(body) # Нужно передавать в озон именно так, потому что string он как json не понимает
  req = requests.post(url + method, headers=head, data=body).text
    # возвращаем значение
  
  parsed = json.loads(req)
  sku_full["depth"] = parsed['result'][0]['depth']
  sku_full["height"] = parsed['result'][0]['height']
  sku_full["width"] = parsed['result'][0]['width']
  sku_full["weight"] = parsed['result'][0]['weight']
  sku_full["weight_unit"] = parsed['result'][0]['weight_unit']
  
  return (sku_full)
  
  
# https://api-seller.ozon.ru
# https://cb-api.ozonru.me
url = "https://api-seller.ozon.ru" # Cсылку нужно поменять на боевую среду api-seller.ozon.ru
method = "/v3/posting/fbs/list" # Список заказов
print(url + method)
head = {
  "Client-Id": "530468", # сюда клиент id
  "Api-Key": "9ebfa77c-bc55-4d5e-8f33-cc02600bdd52" # Сюда Api-Key
 
}
print ("Подключаемся к Озону")
# Сюда пишем параметры запроса
body = {
    "dir": "ASC",
    "filter": 
{
    "since": (datetime.datetime.now()-datetime.timedelta(days=364)).strftime("%Y-%m-%dT%H:%M:%SZ"), #минус год
    "status": "awaiting_deliver", #awaiting_deliver delivering
    "to": datetime.datetime.now().strftime("%Y-%m-%dT%H:%M:%SZ")#сейчас
},
"limit": 100,
"offset": 0,
"translit": True,

}
body = json.dumps(body) # Нужно передавать в озон именно так, потому что string он как json не понимает
response = requests.post(url + method, headers=head, data=body)
print("Ответ сервера Озон:")
print(response)
    
pprint.pprint(response.text) # ответ сервера Озон

parsed_data = json.loads(response.text)
try:
  zakazov = len(parsed_data['result']['postings'])
except:
  print("На серверах Озона нет новых заказов")
else:
  print ("обнаружены новые заказы: ", zakazov)
  
  #Получаем токен в СДЭК ____________________________________________________________________________

  #url = "https://api.edu.cdek.ru" # Cсылку нужно поменять на боевую среду https://api.cdek.ru
  url = "https://api.cdek.ru"
  method = "/v2/oauth/token?parameters" # Сюда вбиваем нужный метод

  #client_id = "EMscd6r9JnFiQ3bLoyjJY6eM78JrJceI" #Тестовые
  #client_secret ="PjLZkKBHEiLK3YsjtNrt3TGNG0ahs3kG"

  client_id = "ICoKCLH27fHrJomoj3ufWd7vsoEduWc4"  #Боевые
  client_secret ="v6ozxEWPiuSSc3XPB15NTgHgxZ1KyM2p"

  params={
              'grant_type': 'client_credentials',
              'client_id': client_id,
              'client_secret': client_secret
          }
  print("Получаем токен безопасности СДЭК")
  s_response = requests.post(url + method, params)
  s_parsed_data = json.loads(s_response.text)

  access_token = s_parsed_data['access_token']
  expires_token = s_parsed_data['expires_in']
  timestamp_token = datetime.datetime.now().timestamp()
  print("Токены получены")

  print('__________________________________________________________')

  count = 0 #считаем количество отгрузок
  for item in parsed_data['result']['postings']:
          id = parsed_data['result']['postings'][count]['status']
          order_number = parsed_data['result']['postings'][count]['order_number']
          customer = parsed_data['result']['postings'][count]['customer']
          products = parsed_data['result']['postings'][count]['products']
          pvz_code = int(parsed_data['result']['postings'][count]['customer']['address']['pvz_code'])
          pvz_code_name = parsed_data['result']['postings'][count]['customer']['address']['provider_pvz_code']
          name = parsed_data['result']['postings'][count]['customer']['name']
          #phone = parsed_data['result']['postings'][count]['customer']['phone']
          posting_number = parsed_data['result']['postings'][count]['posting_number']
          print ("Номер отправления: ", posting_number)
          
          phone = open_phone(posting_number)
          print ("Телефон: ", phone)
          print ("заказ ",count +1, " статус ", id, " номер заказа: ", order_number)
          print ("заказчик: ", customer)
          print ("имя: ", name)
          print ("телефон: ", phone)
          print ("ПВЗ: " , pvz_code, " ", pvz_code_name )
          print ("товары: ", products)
          
          count1 = 0 #Счетчик товаров
          total_weight = 0 #общий вес
          total_height = 0 #высота ширина и глубина
          total_depth = 0
          total_width = 0
          product_items = []#нулевой товар
          
          for item1 in products:
            product = products[count1]
            sku = product['sku']
            product_params = open_sku(sku)
            
            product_name = product['name']
            product_price = product['price']
            product_ware_key = product['offer_id']
            product_weight = int(product_params['weight'])
            product_height = int(product_params['height'])/10
            product_depth = int(product_params['depth'])/10
            product_width = int(product_params['width'])/10
            product_quantity = int(product['quantity'])
            
            total_weight = total_weight + product_weight # считаем общий вес
            
            total_height = round(total_height + product_height)# длину ширину и высоту
            total_depth = round(total_depth + product_depth)
            total_width = round(total_width + product_width)

            print ("параметры груза:", open_sku(sku))
            print("название: ", product_name)
            print("цена: ", product_price)
            print("код: ", product_ware_key)
            print("количество: ", product_quantity)
            print("вес: ", product_weight)
            print("высота: ", product_height, " глубина: ", product_depth, " ширина: ", product_width)
            
            print("общие высота: ", total_height, " глубина: ", total_depth, " ширина: ", total_width)
            
            product_items.append(
              { 
            "ware_key" : product_ware_key,
            "payment" : {
              "value" : 0
            },
            "name" : product_name,
            "cost" : product_price,
            "amount" : product_quantity,
            "weight" : product_weight
            } 
            )  
          print ("__________________________________________________________________")
          count = count + 1
          
  

          s_head ={
              "Authorization": "Bearer " + access_token,
              "Content-Type": "application/json"
          }
          s_method = "/v2/orders" # Создать заказ
          s_body = {
            "number" : order_number,
            "comment" : "",
            
            "from_location" : {
              "code" : "44",
              "fias_guid" : "",
              "postal_code" : "",
              "longitude" : "",
              "latitude" : "",
              "country_code" : "",
              "region" : "",
              "sub_region" : "",
              "city" : "",
              "kladr_code" : "",
              "address" : ""
            },
            
            "packages" : [ {
              "number" : "Номер упаковки 01",
              "height" : total_height,
              "length" : total_depth,
              "width" : total_width,
              "weight" : total_weight,
              "items" : product_items,
              "comment" : "Упаковка"
            } ],
            "recipient" : {
              "name" : name,
              "phones" : [ {
              "number" : phone
            } ]
            },
            "sender" : {
              "company" : "Компания отправитель",
              "name" : "Контакт отправителя"
            },
            
            "seller" : {
              "name" : "Умная энергия",
              "inn" : "7819034380",
              "phone" : "+78123352025",
              "ownership_form" : "137",
            },
            "tariff_code" : 136,
            "delivery_point" : pvz_code_name,
          }

          print("Отправка заказа ",order_number," в СДЭК")
          s_body = json.dumps(s_body) # Нужно передавать в озон именно так, потому что string он как json не понимает
          #req = requests.post(url + method, headers=head, data=body)
          req = requests.post(url + s_method, headers=s_head, data=s_body)
          print("Ответ СДЭК")
          print(req.text)

          print("Проверка заказа ",order_number," в СДЭК")
          uuid = json.loads(req.text)['entity']['uuid']
          
          print ("Внутренний номер заказа: ",uuid)

          s_method = "/v2/orders/"+ uuid #Посмотреть заказ
          req = requests.get(url + s_method, headers=s_head, data="")
          print("____________")
          print("Отчет о приемке в СДЭК")
          print(req.text)

  
  print("количество отгрузок:", count)

  print(response)